package GUI;

import javax.swing.UIManager;

/**
 *
 * @author coolfire
 */
public class Loader extends javax.swing.JFrame {

    private static ConsoleFrame logger;

    /** Creates new form Loader */
    public Loader() {
        initComponents();
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        EnrollButton = new javax.swing.JButton();
        LoginButton = new javax.swing.JButton();
        QuitButton = new javax.swing.JButton();
        ConsoleButton = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Keystroke Dynamics loader");
        setBounds(new java.awt.Rectangle(100, 100, 0, 0));
        setName("GUI_Loader"); // NOI18N
        setResizable(false);

        EnrollButton.setText("Enroll");
        EnrollButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                EnrollButtonActionPerformed(evt);
            }
        });

        LoginButton.setText("Login");
        LoginButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                LoginButtonActionPerformed(evt);
            }
        });

        QuitButton.setText("Quit");
        QuitButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                QuitButtonActionPerformed(evt);
            }
        });

        ConsoleButton.setText("Open console");
        ConsoleButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                ConsoleButtonActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(LoginButton, javax.swing.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                    .addComponent(EnrollButton, javax.swing.GroupLayout.DEFAULT_SIZE, 313, Short.MAX_VALUE)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(ConsoleButton, javax.swing.GroupLayout.PREFERRED_SIZE, 116, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(QuitButton, javax.swing.GroupLayout.DEFAULT_SIZE, 191, Short.MAX_VALUE)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(EnrollButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(LoginButton)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(QuitButton)
                    .addComponent(ConsoleButton))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void LoginButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_LoginButtonActionPerformed
        new Login(logger).setVisible(true);
        logger.add("Opened login window");
    }//GEN-LAST:event_LoginButtonActionPerformed

    private void EnrollButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_EnrollButtonActionPerformed
        new Enroll(logger).setVisible(true);
        logger.add("Opened enroll window");
    }//GEN-LAST:event_EnrollButtonActionPerformed

    private void QuitButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_QuitButtonActionPerformed
        this.dispose();
        logger.add("Stopping");
        System.exit(0);
    }//GEN-LAST:event_QuitButtonActionPerformed

    private void ConsoleButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_ConsoleButtonActionPerformed
        logger.setVisible(true);
        logger.add("Opened console window");
    }//GEN-LAST:event_ConsoleButtonActionPerformed

    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {

        /*
         * Settings for theme and styling.
         * 1st choice: Linux GTK
         * 2nd choice (failover): Windows
         * 3rd choice (2nd failover): Sun nimbus (only available in newer JRE)
         * 4th choice (final failover): Sun standard Java Swing style.
         */
        Boolean setStyle = false;
        String themeLog = "";
        try {
            UIManager.setLookAndFeel("com.sun.java.swing.plaf.gtk.GTKLookAndFeel");
            themeLog = "Selected 'GTK' look and feel";
            setStyle = true;
        }
        catch (Exception e) {
            System.out.println("Unable to load GTK look and feel");
        }

        if(!setStyle) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                setStyle = true;
                themeLog = "Selected 'windows' look and feel";
            }
            catch (Exception e) {
                System.out.println("Unable to load Windows look and feel");
            }
        }

        if(!setStyle) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeels");
                setStyle = true;
                themeLog = "Selected 'nimbus' look and feel";
            }
            catch (Exception e) {
                System.out.println("Unable to load nimbus look and feel");
                themeLog = "Reverted to default Swing look and feel";
            }
        }

        // Start the logging logger
        logger = new ConsoleFrame();
        logger.setVisible(false);
        logger.add("Application started");
        logger.add(themeLog);

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Loader().setVisible(true);
                logger.add("Opened loader window");
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton ConsoleButton;
    private javax.swing.JButton EnrollButton;
    private javax.swing.JButton LoginButton;
    private javax.swing.JButton QuitButton;
    // End of variables declaration//GEN-END:variables

}
