package Keystrokes;

import java.util.ArrayList;

/**
 *
 * @author coolfire
 */
public class Analyzer {
    private GUI.ConsoleFrame logger;
    private Long margin = (long)50;

    public Analyzer(GUI.ConsoleFrame logger) {
        this.logger = logger;
    }

    public boolean validate(PasswordStore known, PasswordStore input) {
        logger.add("Received validation request");
        if(known.getPassword().equals(input.getPassword())) {
            for(int i = 0; i < known.length - 1; i++) {
                if(known.times.get(i) - margin > input.times.get(i) || known.times.get(i) + margin < input.times.get(i)) {
                    logger.add("Times are too far off.");
                    return false;
                }
            }
            return true;
        } else
            logger.add("passwords did not match.");
            return false;
    }

    public PasswordStore takeAverage(PasswordStore one, PasswordStore two, PasswordStore three, PasswordStore four, PasswordStore five) {
        ArrayList<Long> avrgTimes = new ArrayList<Long>();
        for (int i = 0; i < one.length - 1; i++) {
            avrgTimes.add(i, (one.times.get(i) + two.times.get(i) + three.times.get(i) + four.times.get(i) + five.times.get(i)) / 5);
        }
        PasswordStore avrg = new PasswordStore(logger);
        avrg.chars = one.chars;
        avrg.times = avrgTimes;
        avrg.length = one.length;
        return avrg;
    }
    
    /*
     * Check if all the password enties even have the same passwords in them.
     */
    public boolean compareChars(PasswordStore one, PasswordStore two, PasswordStore three, PasswordStore four, PasswordStore five) {
        return 
                (one.getPassword().equals(two.getPassword())) &&
                (one.getPassword().equals(three.getPassword())) &&
                (one.getPassword().equals(four.getPassword())) &&
                (one.getPassword().equals(five.getPassword()));
    }
}
