package Keystrokes;

import java.util.ArrayList;
import java.io.DataOutputStream;
import java.io.DataInputStream;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.IOException;

/**
 *
 * @author coolfire
 */
public class PasswordStore {

    // Luckily Java supports generics for primitive types! Oh wait...
    public ArrayList<Character> chars = new ArrayList<Character>();
    public ArrayList<Long> times = new ArrayList<Long>();
    public int length = 0;
    private Timer t = new Timer();
    private boolean first = true;
    private GUI.ConsoleFrame logger;
    String FILENAME = "password.dat";

    public PasswordStore(GUI.ConsoleFrame logger) {
        this.logger = logger;
    }

    /**
     * Send key when pressed
     */
    public void record(char c){
        if (first)
            first = false;
        else
           times.add(t.stop());

        chars.add(c);
        length++;
        //logger.add("caught character: " + c);
        t.start();
    }

    /**
     * Send after last keypress (when input box loses focus)
     */
    public void stop() {
        t.stop();
        //logger.add("Password recorded"); // Debug line
    }

    /**
     * Save password and keystroke data to file
     */
    public void save() {
        try {
            DataOutputStream os = new DataOutputStream(new FileOutputStream(FILENAME));
            os.writeInt(length);
            for(int i = 0; i < length; i++) {
                os.writeChar(chars.get(i));

                if(i < length - 1)
                    os.writeLong(times.get(i));
            }

            os.close();
            logger.add("Successfully stored password");
        } catch(IOException e) {
            logger.add("Could not write data to file!");
            logger.add(e.toString());
        }
    }

    /**
     * Load keystroke data from file
     */
    public void load() {
        try {
            DataInputStream is = new DataInputStream(new FileInputStream(FILENAME));
            length = is.readInt();
            for(int i = 0; i < length; i++) {
                chars.add(is.readChar());
                if(i < length - 1)
                    times.add(is.readLong());
            }

            is.close();
            logger.add("Successfully loaded stored password");
        } catch(IOException e) {
            logger.add("Could not read data from file!");
            logger.add(e.toString());
        }
    }

    /**
     * Returns the stored password chars as a string
     * @return password
     */
    public String getPassword() {
        return chars.toString();
    }

    @Override
    public String toString() {
        String ret = "length: " + length + "\n";
        for(int i = 0; i < length; i++) {
            ret = ret + chars.get(i);
            if(i < length - 1)
                 ret = ret + " [" + times.get(i) + "ms] ";
            else
                ret = ret + "\n";
        }
        return ret;
    }
}
